"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Shell = void 0;

var _immer = require("immer");

var _utils = require("./utils");

var _secureEventEmitter = require("secure-event-emitter");

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

(0, _immer.enableMapSet)();

var _emitter_key = /*#__PURE__*/new WeakMap();

var _plugins = /*#__PURE__*/new WeakMap();

var Shell = /*#__PURE__*/_createClass(function Shell() {
  var _this = this;

  _classCallCheck(this, Shell);

  _classPrivateFieldInitSpec(this, _emitter_key, {
    writable: true,
    value: Symbol('Shell class emitter key')
  });

  _classPrivateFieldInitSpec(this, _plugins, {
    writable: true,
    value: {}
  });

  _defineProperty(this, "plugins", {});

  _defineProperty(this, "state", {});

  _defineProperty(this, "onStateChange", new _secureEventEmitter.SingularEventEmitter(_classPrivateFieldGet(this, _emitter_key)));

  _defineProperty(this, "onPluginAdd", new _secureEventEmitter.SingularEventEmitter(_classPrivateFieldGet(this, _emitter_key)));

  _defineProperty(this, "onPluginRemove", new _secureEventEmitter.SingularEventEmitter(_classPrivateFieldGet(this, _emitter_key)));

  _defineProperty(this, "setState", function (cb) {
    if (!(0, _utils.isFunction)(cb)) {
      throw new TypeError('[[setState]] argument type must be a [[Function]]');
    }

    var prevState = _this.state;
    _this.state = (0, _immer.produce)(_this.state, function (draft) {
      return cb(draft, function () {
        return (0, _immer.current)(draft);
      });
    });

    _this.onStateChange.unlock(_classPrivateFieldGet(_this, _emitter_key)).emit(_this.state, prevState);
  });

  _defineProperty(this, "getState", function () {
    return _this.state;
  });

  _defineProperty(this, "addPlugin", function (plugin) {
    var _plugin$externalAPI;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var pluginName = plugin.pluginName;

    if (_classPrivateFieldGet(_this, _plugins)[pluginName]) {
      return;
    }

    _this.setState(function (state) {
      state[pluginName] = {};
    });

    var pluginAPI = {};
    var removePlugin = plugin(_this, pluginAPI, pluginName, options);
    _this.plugins[pluginName] = pluginAPI;
    var externalAPI = plugin === null || plugin === void 0 ? void 0 : (_plugin$externalAPI = plugin.externalAPI) === null || _plugin$externalAPI === void 0 ? void 0 : _plugin$externalAPI.call(plugin, pluginAPI);
    var p = {
      pluginName: pluginName,
      plugin: plugin,
      options: options,
      removePlugin: removePlugin
    };
    _classPrivateFieldGet(_this, _plugins)[pluginName] = p;

    if (externalAPI) {
      _this._publicAPI[pluginName] = externalAPI;
    }

    _this.onPluginAdd.unlock(_classPrivateFieldGet(_this, _emitter_key)).emit(p, _classPrivateFieldGet(_this, _plugins));
  });

  _defineProperty(this, "addPlugins", function (plugins) {
    for (var i = 0; i < plugins.length; ++i) {
      _this.addPlugin(plugins[i].plugin, plugins[i].options);
    }
  });

  _defineProperty(this, "removePlugin", function (name) {
    var _plugin$removePlugin;

    var plugin = _classPrivateFieldGet(_this, _plugins)[name];

    if (!plugin) {
      return;
    }

    plugin === null || plugin === void 0 ? void 0 : (_plugin$removePlugin = plugin.removePlugin) === null || _plugin$removePlugin === void 0 ? void 0 : _plugin$removePlugin.call(plugin);
    delete _classPrivateFieldGet(_this, _plugins)[name];
    delete _this.plugins[name];

    _this.setState(function (state) {
      delete state[name];
    });

    delete _this._publicAPI[name];

    _this.onPluginRemove.unlock(_classPrivateFieldGet(_this, _emitter_key)).emit(plugin, _classPrivateFieldGet(_this, _plugins));
  });
});

exports.Shell = Shell;