"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defineExternalAPI = defineExternalAPI;

var _utils = require("./utils");

var _privateSymbol = require("./privateSymbol");

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct.bind(); } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function defineExternalAPI(Private, apiCreator) {
  if (!(0, _utils.isFunction)(apiCreator)) {
    throw new TypeError('defineExternalAPI apiCreator must be a function');
  }

  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _private = (0, _utils.isConstructable)(Private) ? _construct(Private, args) : Private.apply(void 0, args);

    var externalAPI = apiCreator(_private); // require methods

    externalAPI.addPlugin = _private.addPlugin;
    externalAPI.addPlugins = _private.addPlugins;
    externalAPI.removePlugin = _private.removePlugin;
    externalAPI.onStateChange = _private.onStateChange;
    externalAPI.onPluginAdd = _private.onPluginAdd;
    externalAPI.onPluginRemove = _private.onPluginRemove;
    externalAPI.getState = _private.getState;
    _private._publicAPI = externalAPI;
    externalAPI[_privateSymbol.privateSymbol] = _private;
    return externalAPI;
  };
}